# Based on
#
# http://blog.bitify.co.uk/2013/11/connecting-and-calibrating-hmc5883l.html
#

import smbus
import time
import math

bus = smbus.SMBus(1)
address = 0x1e

def write_byte(adr, value):
    bus.write_byte_data(address, adr, value)

def read_signed_word(adr):
    high = bus.read_byte_data(address, adr) 
    low = bus.read_byte_data(address, adr+1)
    val = (high << 8) + low
    if val > 32767:
       val = (65536-val)*-1.0
    return val*1.0

write_byte(0, 0b01110000) # Set to 8 samples @ 15Hz
write_byte(1, 0b00100000) # 1.3 gain LSb / Gauss 1090 (default)
write_byte(2, 0b00000000) # Continuous sampling

scale = 1.0
conv = 180/3.141529

for i in range(0,300):

    x = read_signed_word(3) * scale - 2
    z = read_signed_word(5) * scale
    y = read_signed_word(7) * scale + 115.5

    bearing = math.atan2(y,x)

    if (bearing < 0):
       bearing = bearing + 2*3.141529

    print i, math.degrees(bearing)

    time.sleep(0.1)

